<?php

namespace LakeDrops\ComposerScripts;

use Composer\Script\Event;
use Composer\Script\ScriptEvents;
use LakeDrops\Component\Composer\BasePlugin;

/**
 * Composer plugin for handling drupal scaffold.
 */
class Plugin extends BasePlugin {

  /**
   * {@inheritdoc}
   */
  public function getHandlerClass() {
    return Handler::class;
  }

  /**
   * {@inheritdoc}
   */
  public static function getSubscribedEvents() {
    return array(
      ScriptEvents::POST_CREATE_PROJECT_CMD => 'updateScripts',
      ScriptEvents::POST_INSTALL_CMD => 'updateScripts',
      ScriptEvents::POST_UPDATE_CMD => 'updateScripts',
    );
  }

  /**
   * Update scripts of all LakeDrops plugins.
   *
   * @param \Composer\Script\Event $event
   *   The event that triggered the plugin.
   */
  public function updateScripts(Event $event) {
    $this->handler->updateScripts($event);
  }

  /**
   * Callback to scan plugins for scripts.
   *
   * @param \Composer\Script\Event $event
   *   The event that triggered the plugin.
   */
  public static function scripts(Event $event) {
    $handler = new Handler($event->getComposer(), $event->getIO());
    $handler->updateScripts($event);
  }

}
